Halide 22.0.0 Halide compiler and libraries

Loading...
Searching...
No Matches
Public Attributes | List of all members
Halide::Internal::Autoscheduler::Anderson2021Params Struct Reference

`#include <CostModel.h>`

## Public Attributes
int | parallelism = 16
| Maximum level of parallelism available.
int | beam_size = 32
| Beam size to use in the beam search.
int | random_dropout = 100
| percent chance of accepting each state in the beam.
int64_t | random_dropout_seed = 0
| Random seed used by the random dropout.
std::string | weights_path
| When training or schedule, read weights from this directory or file.
int | disable_subtiling = 0
| If set to nonzero value: limits the search space to that of Mullapudi et al.
int | randomize_tilings = 0
| If set to nonzero value, only a random subset of the generated tilings for each stage will be accepted into the beam.
std::string | search_space_options = "1111"
| Expects a string of four 0/1 values that allow/disallow the following options: compute root, inline, compute at the block level, compute at the thread level e.g.
int | freeze_inline_compute_root = 0
| If set to nonzero value, run a pre-pass where only compute_root and inline scheduling options are considered.
std::string | partial_schedule_path
| If nonempty, load the initial (partial) schedule from the given file.
int | num_passes = 0
| User-requested specific number of passes.
double | stack_factor = 0.95f
| TODO: document me Formerly HL_STACK_FACTOR.
int | shared_memory_limit_kb = 48
| TODO: document me Formerly HL_SHARED_MEMORY_LIMIT.
int | shared_memory_sm_limit_kb = 96
| TODO: document me Formerly HL_SHARED_MEMORY_SM_LIMIT.
int | active_block_limit = 32
| TODO: document me Formerly HL_ACTIVE_BLOCK_LIMIT.
int | active_warp_limit = 64
| TODO: document me Formerly HL_ACTIVE_WARP_LIMIT.

## Detailed Description

Definition at line 18 of file CostModel.h.

## Member Data Documentation

## ◆ parallelism

int Halide::Internal::Autoscheduler::Anderson2021Params::parallelism = 16

Maximum level of parallelism available.

Definition at line 20 of file CostModel.h.

## ◆ beam_size

int Halide::Internal::Autoscheduler::Anderson2021Params::beam_size = 32

Beam size to use in the beam search.

Defaults to 32. Use 1 to get a greedy search instead. Formerly HL_BEAM_SIZE

Definition at line 24 of file CostModel.h.

## ◆ random_dropout

int Halide::Internal::Autoscheduler::Anderson2021Params::random_dropout = 100

percent chance of accepting each state in the beam.

Normalized by the number of decisions made, so 5 would be there's a 5 percent chance of never rejecting any states. Formerly HL_RANDOM_DROPOUT

Definition at line 29 of file CostModel.h.

## ◆ random_dropout_seed

int64_t Halide::Internal::Autoscheduler::Anderson2021Params::random_dropout_seed = 0

Random seed used by the random dropout.

If 0, use time(). Formerly HL_SEED

Definition at line 33 of file CostModel.h.

## ◆ weights_path

std::string Halide::Internal::Autoscheduler::Anderson2021Params::weights_path

When training or schedule, read weights from this directory or file.

(If path ends in `.weights` it is written as a single file, otherwise a directory of files.) Formerly HL_WEIGHTS_DIR

Definition at line 38 of file CostModel.h.

## ◆ disable_subtiling

int Halide::Internal::Autoscheduler::Anderson2021Params::disable_subtiling = 0

If set to nonzero value: limits the search space to that of Mullapudi et al.

Formerly HL_NO_SUBTILING

Definition at line 42 of file CostModel.h.

## ◆ randomize_tilings

int Halide::Internal::Autoscheduler::Anderson2021Params::randomize_tilings = 0

If set to nonzero value, only a random subset of the generated tilings for each stage will be accepted into the beam.

Formerly HL_RANDOMIZE_TILINGS

Definition at line 46 of file CostModel.h.

## ◆ search_space_options

std::string Halide::Internal::Autoscheduler::Anderson2021Params::search_space_options = "1111"

Expects a string of four 0/1 values that allow/disallow the following options: compute root, inline, compute at the block level, compute at the thread level e.g.

1000 would allow compute root only Formerly HL_SEARCH_SPACE_OPTIONS

Definition at line 52 of file CostModel.h.

## ◆ freeze_inline_compute_root

int Halide::Internal::Autoscheduler::Anderson2021Params::freeze_inline_compute_root = 0

If set to nonzero value, run a pre-pass where only compute_root and inline scheduling options are considered.

Formerly HL_FREEZE_INLINE_COMPUTE_ROOT

Definition at line 56 of file CostModel.h.

## ◆ partial_schedule_path

std::string Halide::Internal::Autoscheduler::Anderson2021Params::partial_schedule_path

If nonempty, load the initial (partial) schedule from the given file.

Formerly PARTIAL_SCHEDULE

Definition at line 60 of file CostModel.h.

## ◆ num_passes

int Halide::Internal::Autoscheduler::Anderson2021Params::num_passes = 0

User-requested specific number of passes.

Ignored if 0. Formerly HL_NUM_PASSES

Definition at line 64 of file CostModel.h.

## ◆ stack_factor

double Halide::Internal::Autoscheduler::Anderson2021Params::stack_factor = 0.95f

TODO: document me Formerly HL_STACK_FACTOR.

Definition at line 68 of file CostModel.h.

## ◆ shared_memory_limit_kb

int Halide::Internal::Autoscheduler::Anderson2021Params::shared_memory_limit_kb = 48

TODO: document me Formerly HL_SHARED_MEMORY_LIMIT.

Definition at line 72 of file CostModel.h.

## ◆ shared_memory_sm_limit_kb

int Halide::Internal::Autoscheduler::Anderson2021Params::shared_memory_sm_limit_kb = 96

TODO: document me Formerly HL_SHARED_MEMORY_SM_LIMIT.

Definition at line 76 of file CostModel.h.

## ◆ active_block_limit

int Halide::Internal::Autoscheduler::Anderson2021Params::active_block_limit = 32

TODO: document me Formerly HL_ACTIVE_BLOCK_LIMIT.

Definition at line 80 of file CostModel.h.

## ◆ active_warp_limit

int Halide::Internal::Autoscheduler::Anderson2021Params::active_warp_limit = 64

TODO: document me Formerly HL_ACTIVE_WARP_LIMIT.

Definition at line 84 of file CostModel.h.

The documentation for this struct was generated from the following file:

- src/autoschedulers/anderson2021/CostModel.h